BPL		=	6
STACKSIZE	=	1024

Start:
	moveq	#0,d0
	bra.s	Start2
	dc.l	Start2
Start2:
	move.b	d0,SysStat
	bne.s	Begin
	bsr.L	StartSystem
	lea	Begin,a6
	move.l	a6,$80
	trap	#0
	bsr.L	StopSystem
Strt0:	rts
Begin:	move.l	a7,MemStack
	lea	Stack+STACKSIZE,a7
	lea	CUSTOM,a6
	bsr.s	Program
Halt:	move.l	MemStack,a7
	tst.b	SysStat
	bne.s	Strt0
	rte

;*******************************************************************

Program:
	lea	Pal000,a0
	bsr.L	Fade16B
	lea	CL,a0
	move.l	a0,COP1PTR(a6)
	bsr.L	SetVBL
	bsr.L	OKTPlay
	bsr.L	StartVBL
	move.w	#%1000011111000000,DMACON(a6)

	bsr.L	Set0
	lea	Pal0,a0
	bsr.L	Fade16
	move.l	#100,d0
	bsr.L	Wait
	bsr.s	Fade000

	bsr.L	Set1
	lea	Pal1,a0
	bsr.L	Fade16
	move.l	#75,d0
	bsr.L	Wait
	bsr.s	Fadefff

	bsr.s	Set2
	lea	Pal2,a0
	bsr.L	Fade16
	move.l	#75,d0
	bsr.L	Wait
	lea	Pal2B,a0
	bsr.L	Fade16
	lea	Pal2,a0
	bsr.L	Fade16
	move.l	#75,d0
	bsr.L	Wait
	bsr.s	Fade000

	bsr.L	OKTStop
	rts

;*******************************************************************

Fade000:
	lea	Pal000,a0
	bra.L	Fade16

;*******************************************************************

Fadefff:
	lea	Palfff,a0
	bra.L	Fade16

;*******************************************************************

Set2:
	lea	Intro2,a0
	lea	Aptr1,a1
	lea	Aptr2,a2
	moveq	#BPL-1,d0
Set21:
	move.l	a0,(a1)+
	move.l	a0,(a2)+
	lea	24(a0),a0
	dbf	d0,Set21
	lea	CLDat,a0
	move.w	#72,2(a0)
	move.w	#72,6(a0)
	move.w	#11*8,10(a0)
	move.w	#11*8+88,14(a0)
	move.w	#$0320,18(a0)
	move.w	#$00c0,22(a0)
	move.w	#$0000,26(a0)
	move.w	#COLOR+BPU2,CLOn+2
	move.w	#COLOR,CLOff+2
	move.w	#$8003,CL0
	move.w	#$b803,CLOn+4

	lea	Pal2+2,a0
	lea	Pal2B+2,a1
	moveq	#6,d0
Set28:	move.w	#$fff,(a1)+
	lea	2(a0),a0
	dbf	d0,Set28
	moveq	#15,d0
Set29:	move.w	(a0)+,(a1)+
	dbf	d0,Set29
	rts

;*******************************************************************

Set1:
	lea	Intro1,a0
	lea	Aptr1,a1
	lea	Aptr2,a2
	moveq	#BPL-1,d0
Set11:
	move.l	a0,(a1)+
	move.l	a0,(a2)+
	lea	20(a0),a0
	dbf	d0,Set11
	lea	CLDat,a0
	move.w	#60,2(a0)
	move.w	#60,6(a0)
	move.w	#15*8,10(a0)
	move.w	#15*8+32,14(a0)
	move.w	#$0320,18(a0)
	move.w	#$00c0,22(a0)
	move.w	#$0088,26(a0)
	move.w	#COLOR+BPU2+HIRES,CLOn+2
	move.w	#COLOR+HIRES,CLOff+2
	move.w	#$7803,CL0
	move.w	#$d803,CLOn+4
	rts

;*******************************************************************

Set0:
	lea	Intro0,a0
	lea	Aptr1,a1
	moveq	#BPL-1,d0
Set01:	move.l	a0,(a1)+
	lea	40(a0),a0
	dbf	d0,Set01
	lea	Intro0,a0
	lea	200(a0),a0
	lea	Aptr2,a1
	moveq	#BPL-1,d0
Set02:	move.l	a0,(a1)+
	lea	40(a0),a0
	dbf	d0,Set02
	lea	CLDat,a0
	move.w	#360,2(a0)
	move.w	#360,6(a0)
	move.w	#7*8,10(a0)
	move.w	#7*8+152,14(a0)
	move.w	#$0320,18(a0)
	move.w	#$00c0,22(a0)
	move.w	#$0088,26(a0)
	move.w	#COLOR+BPU0+BPU2+LACE,CLOn+2
	move.w	#COLOR+LACE,CLOff+2
	rts

;*******************************************************************

Wait:
	move.l	d0,CNT
Wa:	tst.l	CNT
	bne.s	Wa
	rts

;*******************************************************************

Fade16:
	move.w	#16,d7
Fade0:	movem.l	d7/a0,-(sp)
	bsr.L	WVBL
	bsr.s	Fade
	movem.l	(sp)+,d7/a0
	dbf	d7,Fade0
	rts

;*******************************************************************

Fade16B:
	move.w	#16,d7
Fade0B:	movem.l	d7/a0,-(sp)
	bsr.s	Fade
	movem.l	(sp)+,d7/a0
	dbf	d7,Fade0B
	rts

;*******************************************************************

;a0-palette a1-copperlist
Fade:
	lea	CLCol,a1
	move.w	#31,d0
Fa1:
	move.w	2(a1),d1
	move.w	(a0)+,d2
	move.w	d1,d3
	move.w	d2,d4
	and.w	#$f00,d3
	and.w	#$f00,d4
	cmp.w	d3,d4
	beq.s	Fa2a
	bcs.s	Fa3a
	add.w	#$100,d1
	bra.s	Fa2a
Fa3a:	sub.w	#$100,d1
Fa2a:
	move.w	d1,d3
	move.w	d2,d4
	and.w	#$0f0,d3
	and.w	#$0f0,d4
	cmp.w	d3,d4
	beq.s	Fa2b
	bcs.s	Fa3b
	add.w	#$010,d1
	bra.s	Fa2b
Fa3b:	sub.w	#$010,d1
Fa2b:
	move.w	d1,d3
	move.w	d2,d4
	and.w	#$00f,d3
	and.w	#$00f,d4
	cmp.w	d3,d4
	beq.s	Fa2c
	bcs.s	Fa3c
	add.w	#$001,d1
	bra.s	Fa2c
Fa3c:	sub.w	#$001,d1
Fa2c:
	move.w	d1,2(a1)
	lea	4(a1),a1
	dbf	d0,Fa1
	rts

;*******************************************************************

WVBL:
	sf	ByloVBL
WVBL0:	tst.b	ByloVBL
	beq.s	WVBL0
	rts

;*******************************************************************

ProcVBL:
	tst.l	CNT
	beq.s	Pr0
	sub.l	#1,CNT
Pr0:
	st	ByloVBL
	lea	Aptr1,a0
	move.w	VPOSR(a6),d0
	btst	#15,d0
	bne.s	Pr1
	lea	Aptr2,a0
Pr1:
	lea	CLPtr,a1
	moveq	#BPL-1,d0
Pr2:
	move.l	(a0)+,d1
	move.w	d1,6(a1)
	swap	d1
	move.w	d1,2(a1)
	swap	d1
	lea	8(a1),a1
	dbf	d0,Pr2
	rts

;*******************************************************************

VBL:
	move.w	d0,-(sp)
	move.w	INTREQR+CUSTOM,d0
	btst	#5,d0
	beq.s	QuitV
	tst.b	WykonujVBL
	beq.s	QuitV
	movem.l	d0-d7/a0-a6,-(sp)
	lea	CUSTOM,a6
	bsr.L	ProcVBL
	movem.l	(sp)+,d0-d7/a0-a6
QuitV:	and.w	#$7fff,d0
	move.w	d0,INTREQ+CUSTOM
	move.w	(sp)+,d0
	rte

;*******************************************************************

StartVBL:
	st	WykonujVBL
	rts

;*******************************************************************

StopVBL:
	sf	WykonujVBL
	rts

;*******************************************************************

SetVBL:
	sf	WykonujVBL
	lea	VBL,a0
	move.l	a0,$6c
	move.w	#SETCLR+%100000+$4000,INTENA(a6)
	rts

;*******************************************************************

LMK:
	btst	#6,$bfe001
	bne.s	LMK
LMK0:
	btst	#6,$bfe001
	beq.s	LMK0
	rts

;*******************************************************************

WaitBlt:
	btst	#6,$dff002
WaBl1:	btst	#6,$dff002
	bne.s	WaBl1
	rts

;*******************************************************************

StartSystem:
	movem.l	d0-d7/a0-a6,-(sp)
	lea	GfxLibName,a1
	move.l	ExecBase,a6
	jsr	OldOpenLibrary(a6)
	move.l	d0,GfxLibBase
	exg	d0,a6
	jsr	OwnBlitter(a6)
	bsr.s	WaitBlt
	move.l	ExecBase,a6
	jsr	Forbid(a6)
	move.w	$dff002,MemDma
	move.w	$dff01c,MemInt
	or.w	#$8000,MemDma
	or.w	#$8000,MemInt
	move.w	#$7fff,$dff09a
	move.w	#$7fff,$dff096
	lea	MemVectors,a0
	lea	0,a1
	lea	Reset,a2
	moveq	#63,d0
StSy1:	move.l	(a1),(a0)+
	move.l	a2,(a1)+
	dbf	d0,StSy1
	bsr.s	InstEI
	movem.l	(sp)+,d0-d7/a0-a6
	rts

;*******************************************************************

StopSystem:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	#$7fff,$dff09a
	move.w	#$7fff,$dff096
	lea	MemVectors,a0
	lea	0,a1
	moveq	#63,d0
StSs1:	move.l	(a0)+,(a1)+
	dbf	d0,StSs1
	move.l	GfxLibBase,a6
	move.l	$26(a6),$dff080
	move.w	MemDma,$dff096
	move.w	MemInt,$dff09a
	move.l	ExecBase,a6
	jsr	Permit(a6)
	move.l	GfxLibBase,a6
	jsr	DisownBlitter(a6)
	exg	a6,a1
	move.l	ExecBase,a6
	jsr	CloseLibrary(a6)
	movem.l	(sp)+,d0-d7/a0-a6
	rts

;*******************************************************************

InstEI:
	lea	EmptyInt,a0
	move.l	a0,$64
	move.l	a0,$68
	move.l	a0,$6c
	move.l	a0,$70
	move.l	a0,$74
	move.l	a0,$78
	move.l	a0,$7c
	rts

;*******************************************************************

EmptyInt:
	move.w	d0,-(sp)
	move.w	INTREQR+CUSTOM,d0
	and.w	#$7fff,d0
	move.w	d0,INTREQ+CUSTOM
	move.w	(sp)+,d0
	rte

;*******************************************************************

Reset:
	move.w	#$7fff,$dff09a
	move.w	#$7fff,$dff096
	lea	ResetP,a0
	move.l	a0,$80
	trap	#0
ResetP:	clr.l	ExecBase
	lea	2,a0
	reset
	jmp	(a0)

;*******************************************************************

OKTPlay:
		rts
		jsr	sj_init
		jsr	rs_init
		lea	rs_int,a0
		move.l	a0,$6c.w
		lea	rs_audint,a0
		move.l	a0,$70.w
		move.w	#$780,$dff09c
		move.w	#$780,$dff09a
		move.w	#$c000,$dff09a
		rts
OKTStop:
		rts
		jsr	rs_exit
		rts

Empty:		dc.l	0

* SJ **********************************

sj_init:
		lea	rs_channelmodes,a0
		move.l	a0,rs_cmformat+8
		lea	rs_samples,a0
		move.l	a0,rs_extformat+8
		lea	rs_speed,a0
		move.l	a0,rs_extformat+20
		lea	rs_len,a0
		move.l	a0,rs_extformat+32
		lea	rs_patterns,a0
		move.l	a0,rs_extformat+44

		lea	rs_songend,a0
		move.l	a0,rs_loop+2
		move.l	a0,rs_loop2+2
		move.l	a0,rs_loop2a+2

		rts

* p ***********************************

p:		bsr.s	rs_init
		bmi.s	rs_error
rs_left:	btst	#6,$bfe001
		bne.s	rs_left
		bsr	rs_exit
		moveq	#0,d0
		rts
rs_error:	moveq	#100,d0
		rts

* init ********************************

rs_init:	lea	rs_song,a5
		cmp.l	#'OKTA',(a5)+
		bne	rs_error2
		cmp.l	#'SONG',(a5)+
		bne	rs_error2
		move.l	a5,a0
		lea	rs_cmformat(pc),a1
		bsr	rs_search
		lea	rs_channelmodes(pc),a0
		tst.l	(a0)+
		bne	rs_error2
		tst.l	(a0)+
		bne	rs_error2
		move.l	a5,a0
		lea	rs_extformat(pc),a1
		bsr	rs_search
		move.l	a5,a0
		bsr	rs_getpatts
		move.l	a5,a0
		bsr	rs_getsamples

		clr.w	rs_pointer
		bsr	rs_gettrkpos
		sub.l	#16,rs_trkpos
		subq.w	#1,rs_patty

		move.l	#$40404040,rs_vol
		clr.w	rs_filter
		clr.l	0.w
		move.w	rs_speed,rs_actspeed
		clr.w	rs_actcyc
		move.w	#-1,rs_nextpt

		lea	rs_pbuffs,a0
		moveq	#15,d0
rs_loop4:	clr.l	(a0)+
		dbf	d0,rs_loop4
		lea	rs_pattline,a0
		moveq	#3,d0
rs_loop5:	clr.l	(a0)+
		dbf	d0,rs_loop5

		move.w	#$ff,$dff09e
		move.w	#$4000,$dff09a
		move.l	$6c.w,rs_oldint+2
		move.l	$70.w,rs_oldaud
		move.l	#rs_int,$fc.w		;rel
		move.l	#rs_audint,$fc.w	;rel
		move.w	#$780,Empty
		move.w	#$780,Empty
		move.w	#$c000,Empty
		moveq	#0,d0
		rts
rs_error2:	moveq	#-1,d0
		rts

* format search ***********************

;a0:fpt
;a1:format list

rs_search:	move.l	a0,a2
		move.l	(a1)+,d0
		beq.s	rs_ex
rs_loop:	cmp.l	#rs_songend,a2		;rel
		beq.s	rs_ex
		cmp.l	(a2)+,d0
		bne.s	rs_next
		move.l	(a1)+,d0
		cmp.l	(a2)+,d0
		ble.s	rs_nocorrect
		move.l	-4(a2),d0
rs_nocorrect:	move.l	(a1)+,a3
rs_copy:	subq.l	#1,d0
		bmi.s	rs_search
		move.b	(a2)+,(a3)+
		bra.s	rs_copy
rs_next:	add.l	(a2)+,a2
		bra.s	rs_loop
rs_ex:		rts

* pattern descriptor ******************

rs_getpatts:	lea	rs_pattpts(pc),a1
		move.l	#'PBOD',d0
rs_loop2:	cmp.l	#rs_songend,a0		;rel
		beq.s	rs_ready
		movem.l	(a0)+,d1-d2
		cmp.l	d0,d1
		beq.s	rs_got
		add.l	d2,a0
		bra.s	rs_loop2
rs_got:		move.l	a0,(a1)+
		add.l	d2,a0
		bra.s	rs_loop2
rs_ready:	rts

* sample descriptor *******************

rs_getsamples:	lea	rs_samplepts(pc),a1
		lea	rs_samples,a2
		move.l	#'SBOD',d0
rs_loop2a:	cmp.l	#rs_songend,a0		;rel
		beq.s	rs_sready
		movem.l	(a0)+,d1-d2
		cmp.l	d0,d1
		beq.s	rs_gots
		add.l	d2,a0
		bra.s	rs_loop2a
rs_gots:	tst.l	20(a2)
		bne.s	rs_setsample
		lea	32(a2),a2
		clr.l	(a1)+
		bra.s	rs_gots
rs_setsample:	move.l	a0,(a1)+
		lea	32(a2),a2
		add.l	d2,a0
		bra.s	rs_loop2a
rs_sready:	rts

* exit ********************************

rs_exit:	move.w	#$4000,$dff09a
		move.l	rs_oldint+2,$6c.w
		move.l	rs_oldaud,$70.w
		move.w	#$c000,$dff09a
		lea	$dff000,a6
		moveq	#0,d0
		move.w	#$f,$96(a6)
		move.w	d0,$a8(a6)
		move.w	d0,$b8(a6)
		move.w	d0,$c8(a6)
		move.w	d0,$d8(a6)
		rts

rs_int:		btst	#5,$dff01f
		beq.s	rs_oldint
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	rs_rh
		movem.l	(sp)+,d0-d7/a0-a6
rs_oldint:	jmp	0

rs_rh:		bsr	rs_p4
		addq.w	#1,rs_actcyc
		move.w	rs_actspeed,d0
		cmp.w	rs_actcyc,d0
		ble.s	rs_addcyc
		rts

rs_addcyc:	clr.w	rs_actcyc
		moveq	#16,d0
		add.l	d0,rs_trkpos
		addq.w	#1,rs_patty
		bsr	rs_getppatt
		tst.w	rs_nextpt
		bpl.s	rs_pattend
		cmp.w	rs_patty,d0
		bgt.s	rs_nonew
rs_pattend:	clr.w	rs_patty
		tst.w	rs_nextpt
		bmi	rs_nonextpt
		move.w	rs_nextpt,rs_pointer
		bra.s	rs_newpos
rs_nonextpt:	addq.w	#1,rs_pointer
rs_newpos:	move.w	rs_pointer,d0
		cmp.w	rs_len,d0
		bne.s	rs_nonewinit
		clr.w	rs_pointer
		move.w	rs_speed,rs_actspeed
rs_nonewinit:	bsr	rs_gettrkpos
rs_nonew:	move.l	rs_trkpos,a0
		lea	rs_pattline,a1
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.w	#-1,rs_nextpt
		rts

rs_p4:		tst.w	rs_actcyc
		bne.s	rs_effects

		bsr	rs_set
		tst.w	d4
		beq.s	rs_effects
		bsr	rs_dma
		bsr	rs_setperiods
		or.w	#$8000,d4
		move.w	d4,$dff096
		bsr	rs_dma
		bsr	rs_action

rs_effects:	bsr	rs_effect
		lea	rs_vol,a0
		lea	$dff0a9,a1
		move.b	(a0)+,(a1)
		move.b	(a0)+,$10(a1)
		move.b	(a0)+,$20(a1)
		move.b	(a0)+,$30(a1)
		tst.b	rs_filter
		beq.s	rs_blink
		bclr	#1,$bfe001
		rts
rs_blink:	bset	#1,$bfe001
		rts

rs_set:		lea	rs_samplepts,a0
		lea	rs_pattline,a2
		lea	rs_pbuffs,a3
		lea	$dff0a0,a4
		lea	rs_periods,a6

		moveq	#0,d4
		moveq	#1,d5
		moveq	#3,d7

rs_ploop:	bsr.s	rs_set4
		addq.w	#4,a2
		lea	16(a3),a3
		lea	$10(a4),a4
		add.w	d5,d5
		dbf	d7,rs_ploop
		rts

rs_set4:	moveq	#0,d3
		move.b	(a2),d3
		beq	rs_noset
		subq.w	#1,d3
		moveq	#0,d0
		move.b	1(a2),d0
		add.w	d0,d0
		add.w	d0,d0
		move.l	(a0,d0.w),d2
		beq	rs_noset
		lsl.w	#3,d0
		lea	rs_samples,a1
		add.w	d0,a1
		tst.w	30(a1)
		beq	rs_noset
		move.l	20(a1),d1
		lsr.l	#1,d1
		tst.w	d1
		beq	rs_noset
		move.w	#124,6(a4)
		lsl.w	#7,d5
		move.w	d5,$dff09a
		lsr.w	#7,d5
		move.w	d5,$dff096
		or.w	d5,d4
		move.l	d2,(a4)
		move.w	d3,12(a3)
		add.w	d3,d3
		move.w	(a6,d3.w),14(a3)
		move.l	a0,-(sp)
		lea	rs_vol,a0
		moveq	#0,d0
		move.b	rs_volum1(pc,d7.w),d0
		move.b	29(a1),(a0,d0.w)
		move.l	(sp)+,a0
		tst.w	26(a1)
		beq.s	rs_norep
		tst.w	24(a1)
		bne.s	rs_realrep

		move.w	26(a1),4(a4)
		clr.l	(a3)
		clr.w	4(a3)
		moveq	#0,d0
		move.w	26(a1),d0
		add.l	d0,d0
		add.l	d0,d2
		move.l	d2,6(a3)
		move.l	20(a1),d1
		sub.l	d0,d1
		lsr.l	#1,d1
		move.w	d1,10(a3)
		rts

rs_volum1:	dc.b	3,2,1,0

rs_realrep:	move.w	24(a1),4(a4)
		moveq	#0,d0
		move.w	24(a1),d0
		add.l	d0,d0
		add.l	d2,d0
		move.l	d0,(a3)
		move.w	26(a1),4(a3)
		moveq	#0,d0
		move.w	24(a1),d0
		add.w	26(a1),d0
		add.l	d0,d0
		add.l	d0,d2
		move.l	d2,6(a3)
		move.l	20(a1),d1
		sub.l	d0,d1
		lsr.l	#1,d1
		move.w	d1,10(a3)
		rts

rs_norep:	move.w	d1,4(a4)
		moveq	#2,d0
		move.l	d0,(a3)
		move.w	#1,4(a3)
		clr.l	6(a3)
		clr.w	10(a3)
rs_noset:	rts

rs_setperiods:	lea	rs_pbuffs,a3
		lea	$dff000,a4
		btst	#0,d4
		beq.s	rs_notc1
		move.w	14(a3),$a6(a4)
rs_notc1:	btst	#1,d4
		beq.s	rs_notc2
		move.w	14+16(a3),$b6(a4)
rs_notc2:	btst	#2,d4
		beq.s	rs_notc3
		move.w	14+32(a3),$c6(a4)
rs_notc3:	btst	#3,d4
		beq.s	rs_notc4
		move.w	14+48(a3),$d6(a4)
rs_notc4:	rts

rs_action:	lea	rs_pbuffs,a3
		lea	$dff0a0,a4
		moveq	#3,d7
rs_aloop:	move.l	(a3),d0
		beq.s	rs_nopt
		move.l	d0,(a4)
		clr.l	(a3)
rs_nopt:	move.w	4(a3),d0
		beq.s	rs_nolen
		move.w	d0,4(a4)
		clr.w	4(a3)
rs_nolen:	lea	16(a3),a3
		lea	$10(a4),a4
		dbf	d7,rs_aloop
		rts

rs_effect:	lea	p(pc),a1
		lea	rs_pattline,a2
		lea	rs_pbuffs,a3
		lea	$dff0a0,a4
		lea	rs_periods,a6
		moveq	#1,d5
		moveq	#3,d7
rs_eloop:	bsr	rs_doeff
		addq.w	#4,a2
		lea	$10(a3),a3
		lea	$10(a4),a4
		add.w	d5,d5
		dbf	d7,rs_eloop
		rts

rs_doeff:	moveq	#0,d0
		move.b	2(a2),d0
		add.w	d0,d0
		moveq	#0,d1
		move.b	3(a2),d1

		move.w	rs_effecttab(pc,d0.w),d0
		beq.s	rs_noeff
		bmi.s	rs_1eff

		jsr	(a1,d0.w)
		bra.s	rs_noeff

rs_1eff:	tst.w	rs_actcyc
		bne.s	rs_noeff
		neg.w	d0
		jsr	(a1,d0.w)
rs_noeff:	rts

rs_effecttab:	dc.w	0,rs_portd-p,rs_portu-p,0,0,0
		dc.w	0,0,0,0,rs_arp-p,rs_arp2-p
		dc.w	0,rs_slided-p,0,p-rs_filt,0,p-rs_slideu
		dc.w	0,0,0,p-rs_slided,0,0
		dc.w	0,p-rs_posjmp,0,p-rs_release,p-rs_cspeed,0
		dc.w	rs_slideu-p,rs_volume-p,0,0,0,0

rs_portd:	sub.w	d1,14(a3)
		bpl.s	rs_pdok
		move.w	#113,14(a3)
rs_pdok:	move.w	14(a3),6(a4)
		rts

rs_portu:	add.w	d1,14(a3)
		bpl.s	rs_puok
		move.w	#113,14(a3)
rs_puok:	move.w	14(a3),6(a4)
		rts

rs_arp:		move.w	12(a3),d2
		move.w	rs_actcyc,d0
		move.b	rs_divtab(pc,d0.w),d0
		bne.s	rs_val1
		and.w	#$f0,d1		;runter
		lsr.w	#4,d1
		sub.w	d1,d2
		bra.s	rs_setarp

rs_val1:	subq.b	#1,d0
		bne.s	rs_val2
		move.w	d2,8(a4)
		bra.s	rs_setarp

rs_val2:	and.w	#$0f,d1
		add.w	d1,d2
		bra.s	rs_setarp

rs_divtab:	dc.b	0,1,2,0,1,2,0,1,2,0,1,2,0,1,2,0,1,2

rs_arp2:	move.w	12(a3),d2
		move.w	rs_actcyc,d0
		and.w	#3,d0
		bne.s	rs_val3
		bra.s	rs_setarp

rs_val3:	subq.b	#1,d0
		bne.s	rs_val4
		and.w	#$f,d1
		add.w	d1,d2
		bra.s	rs_setarp

rs_val4:	subq.b	#1,d0
		beq.s	rs_setarp
		and.w	#$f0,d1
		lsr.w	#4,d1
		sub.w	d1,d2

rs_setarp:	tst.w	d2
		bpl.s	rs_arpok1
		moveq	#0,d2
rs_arpok1:	cmp.w	#35,d2
		ble.s	rs_arpok2
		moveq	#35,d2
rs_arpok2:	add.w	d2,d2
		move.w	(a6,d2.w),d0
		move.w	d0,6(a4)
		move.w	d0,14(a3)
		rts

rs_slided:	move.w	12(a3),d2
		sub.w	d1,d2
		move.w	d2,12(a3)
		bra.s	rs_setarp

rs_slideu:	move.w	12(a3),d2
		add.w	d1,d2
		move.w	d2,12(a3)
		bra.s	rs_setarp

rs_cspeed:	tst.b	d1
		beq.s	rs_nochange
		and.w	#$f,D1
		move.w	d1,rs_actspeed
rs_nochange:	rts

rs_filt:	tst.b	d1
		sne	rs_filter
		rts

rs_volume:	move.l	a0,-(sp)
		lea	rs_vol,a0
		moveq	#0,d0
		move.b	volum2(pc,d7.w),d0
		add.w	d0,a0
		cmp.w	#$40,d1
		bgt.s	rs_4567
		move.b	d1,(a0)
rs_vex:		move.l	(sp)+,a0
		rts

volum2:		dc.b	3,2,1,0

rs_4567:	sub.b	#$40,d1
		cmp.b	#$10,d1
		blt.s	rs_4
		sub.b	#$10,d1
		cmp.b	#$10,d1
		blt.s	rs_5
		sub.b	#$10,d1
		cmp.b	#$10,d1
		blt.s	rs_6
		sub.b	#$10,d1
		cmp.b	#$10,d1
		blt.s	rs_7
		bra.s	rs_vex

rs_6:		tst.w	rs_actcyc
		bne.s	rs_vex

rs_4:		sub.b	d1,(a0)
		bpl.s	rs_vex
		clr.b	(a0)
		bra.s	rs_vex

rs_7:		tst.w	rs_actcyc
		bne.s	rs_vex

rs_5:		add.b	d1,(a0)
		cmp.b	#$40,(a0)
		ble.s	rs_vex
		move.b	#$40,(a0)
		bra.s	rs_vex

rs_release:	tst.l	6(a3)
		beq.s	rs_rex
		tst.w	10(a3)
		beq.s	rs_rex
		move.w	d5,d0
		lsl.w	#7,d0
		move.w	d0,$dff09a
		move.l	6(a3),(a4)
		move.w	10(a3),4(a4)
		clr.l	6(a3)
		clr.w	10(a3)
		move.w	d0,$dff09c
		or.w	#$8000,d0
		move.w	d0,$dff09a
rs_rex:		rts

rs_posjmp:	move.w	d1,d0
		and.w	#$f,d0
		lsr.w	#4,d1
		mulu	#10,d1
		add.w	d1,d0
		cmp.w	rs_len,d0
		bge.s	rs_nojmp
		move.w	d0,rs_nextpt
rs_nojmp:	rts

rs_audint:	movem.l	d0-d1/a0,-(sp)
		lea	$dff000,a0
		move.w	$1e(a0),d0
		and.w	$1c(a0),d0
		moveq	#0,d1
		btst	#7,d0
		beq.s	rs_let1
		move.l	d1,$a0(a0)
		move.w	#1,$a4(a0)
		move.w	#$80,$9a(a0)
rs_let1:	btst	#8,d0
		beq.s	rs_let2
		move.l	d1,$b0(a0)
		move.w	#1,$b4(a0)
		move.w	#$100,$9a(a0)
rs_let2:	btst	#9,d0
		beq.s	rs_let3
		move.l	d1,$c0(a0)
		move.w	#1,$c4(a0)
		move.w	#$200,$9a(a0)
rs_let3:	btst	#10,d0
		beq.s	rs_let4
		move.l	d1,$d0(a0)
		move.w	#1,$d4(a0)
		move.w	#$400,$9a(a0)
rs_let4:	movem.l	(sp)+,d0-d1/a0
		rte

rs_gettrkpos:	lea	rs_patterns,a0
		add.w	rs_pointer,a0
		moveq	#0,d0
		move.b	(a0),d0
		bsr.s	rs_getpattern
		move.l	a0,rs_trkpos
		clr.w	rs_patty
		rts

rs_getppatt:	lea	rs_patterns,a0
		add.w	rs_pointer,a0
		moveq	#0,d0
		move.b	(a0),d0
rs_getpattern:	lea	rs_pattpts,a0
		add.w	d0,d0
		add.w	d0,d0
		move.l	(a0,d0.w),a0
		move.w	(a0)+,d0
		rts

rs_dma:		movem.w	d0-d1,-(sp)
		move.w	#4,d1
rs_nextline:	move.b	$dff006,d0
rs_waitline:	cmp.b	$dff006,d0
		beq.s	rs_waitline
		dbf	d1,rs_nextline
		movem.w	(sp)+,d0-d1
		rts

rs_cmformat:	dc.l	'CMOD',8,rs_channelmodes	;rel
rs_extformat:	dc.l	'SAMP',36*32,rs_samples		;rel
		dc.l	'SPEE',2,rs_speed		;rel
		dc.l	'PLEN',2,rs_len			;rel
		dc.l	'PATT',128,rs_patterns,0	;rel
rs_channelmodes:ds.w	4
rs_samples:	ds.b	36*32
rs_speed:	dc.w	6
rs_len:		dc.w	1
rs_patterns:	ds.b	128
rs_pattpts:	ds.l	64
rs_samplepts:	ds.l	36
rs_patty:	ds.w	1
rs_trkpos:	ds.l	1
rs_pbuffs:	ds.l	16
rs_pattline:	ds.l	4
rs_actspeed:	ds.w	1
rs_actcyc:	ds.w	1
rs_nextpt:	ds.w	1
rs_pointer:	ds.w	1
rs_vol:		ds.l	1
rs_filter:	ds.w	1
rs_oldaud:	ds.l	1
rs_periods:	dc.w	$358,$328,$2FA,$2D0,$2A6,$280,$25C,$23A,$21A
		dc.w	$1FC,$1E0,$1C5,$1AC,$194,$17D,$168,$153,$140
		dc.w	$12E,$11D,$10D,$FE,$F0,$E2,$D6,$CA,$BE
		dc.w	$B4,$AA,$A0,$97,$8F,$87,$7F,$78,$71



;*******************************************************************
;			CONSTANS
;*******************************************************************

ExecBase	=	4
OldOpenLibrary	=	-408
CloseLibrary	=	-414
OwnBlitter	=	-456
DisownBlitter	=	-462
Forbid		=	-132
Permit		=	-138
CUSTOM		=	$dff000
BLTDDAT		=	$000
DMACONR		=	$002
VPOSR		=	$004
VHPOSR		=	$006
DSKDATR		=	$008
JOY0DAT		=	$00A
JOY1DAT		=	$00C
CLXDAT		=	$00E
ADKCONR		=	$010
POT0DAT		=	$012
POT1DAT		=	$014
POTGOR		=	$016
SERDATR		=	$018
DSKBYTR		=	$01A
INTENAR		=	$01C
INTREQR		=	$01E
DSKPTH		=	$020
DSKPTL		=	$022
DSKLEN		=	$024
DSKDAT		=	$026
REFPTR		=	$028
VPOSW		=	$02A
VHPOSW		=	$02C
COPCON		=	$02E
SERDAT		=	$030
SERPER		=	$032
POTGO		=	$034
JOYTEST		=	$036
STRQU		=	$038
STRVBL		=	$03A
STRHOR		=	$03C
STRLONG		=	$03E
BLTCON0		=	$040
BLTCON1		=	$042
BLTAFWM		=	$044
BLTALWM		=	$046
BLTCPT		=	$048
BLTBPT		=	$04C
BLTAPT		=	$050
BLTDPT		=	$054
BLTSIZE		=	$058
BLTCMOD		=	$060
BLTBMOD		=	$062
BLTAMOD		=	$064
BLTDMOD		=	$066
BLTCDAT		=	$070
BLTBDAT		=	$072
BLTADAT		=	$074
DSKSYNC		=	$07E
COP1PTR		=	$080
COP2PTR		=	$084
COP1LCH		=	$080
COP1LCL		=	$082
COP2LCH		=	$084
COP2LCL		=	$086
COPJMP1		=	$088
COPJMP2		=	$08A
COPINS		=	$08C
DIWSTRT		=	$08E
DIWSTOP		=	$090
DDFSTRT		=	$092
DDFSTOP		=	$094
DMACON		=	$096
CLXCON		=	$098
INTENA		=	$09A
INTREQ		=	$09C
ADKCON		=	$09E
AUDIO0		=	$0A0
AUDIO1		=	$0B0
AUDIO2		=	$0C0
AUDIO3		=	$0D0
BPL1PTH		=	$0E0
BPL1PTL		=	$0E2
BPL2PTH		=	$0E4
BPL2PTL		=	$0E6
BPL3PTH		=	$0E8
BPL3PTL		=	$0EA
BPL4PTH		=	$0EC
BPL4PTL		=	$0EE
BPL5PTH		=	$0F0
BPL5PTL		=	$0F2
BPL6PTH		=	$0F4
BPL6PTL		=	$0F6
BPLCON0		=	$100
BPLCON1		=	$102
BPLCON2		=	$104
BPL1MOD		=	$108
BPL2MOD		=	$10A
SPRPTR		=	$120
SPRPOS		=	$140
COLORS		=	$180
SETCLR		=	$8000
DSKEN		=	$10
SPREN		=	$20
BLTEN		=	$40
COPEN		=	$80
BPLEN		=	$100
DMAEN		=	$200
BLTPR		=	$400
ERSY		=	$2
LACE		=	$4
LPEN		=	$8
GAUD		=	$100
COLOR		=	$200
DBLPF		=	$400
HOMOD		=	$800
BPU0		=	$1000
BPU1		=	$2000
BPU2		=	$4000
HIRES		=	$8000
COPWAIT		=	$fffe
ENDCOPLST	=	$ffff
ENDHALF		=	$ffdf
KEYTALO		=	$bfe401
KEYTAHI		=	$bfe501
KEYCRA		=	$bfee01
KEYSDR		=	$bfec01
KEYICR		=	$bfed01
TBLO		=	$bfd600
TBHI		=	$bfd700
CRB		=	$bfdf00
ICR		=	$bfdd00
SPR0POS		=	$140
SPR0CTL		=	$142
SPR0DATA	=	$144
SPR0DATB	=	$146
SPR1POS		=	$148
SPR1CTL		=	$14a
SPR1DATA	=	$14c
SPR1DATB	=	$14e
SPR2POS		=	$150
SPR2CTL		=	$152
SPR2DATA	=	$154
SPR2DATB	=	$156
SPR3POS		=	$158
SPR3CTL		=	$15a
SPR3DATA	=	$15c
SPR3DATB	=	$15e
SPR4POS		=	$160
SPR4CTL		=	$162
SPR4DATA	=	$164
SPR4DATB	=	$166
SPR5POS		=	$168
SPR5CTL		=	$16a
SPR5DATA	=	$16c
SPR5DATB	=	$16e
SPR6POS		=	$170
SPR6CTL		=	$172
SPR6DATA	=	$174
SPR6DATB	=	$176
SPR7POS		=	$178
SPR7CTL		=	$17a
SPR7DATA	=	$17c
SPR7DATB	=	$17e

;*******************************************************************
;			FAST DATA
;*******************************************************************

	;--- System. ---

SysStat:	dc.b	0
GfxLibName:	dc.b	'graphics.library',0
	EVEN

	incdir	'DH1:Sources/asm/robbo/bin/introbin/'

Pal0:		incbin	'Intro0.PAL'
Pal1:		incbin	'Intro1.PAL'
Pal2:		incbin	'Intro2.PAL'
Pal000:		blk.w	32,$000
Palfff:		blk.w	32,$fff

Aptr1:		blk.l	BPL,0
Aptr2:		blk.l	BPL,0

CNT:		dc.l	0

;*******************************************************************
;			POINTERS
;*******************************************************************

;*******************************************************************
;			CHIP DATA
;*******************************************************************

CL:
		dc.w	SPR0CTL,0,SPR1CTL,0,SPR2CTL,0,SPR3CTL,0
		dc.w	SPR4CTL,0,SPR5CTL,0,SPR6CTL,0,SPR7CTL,0
		dc.w	$1803,COPWAIT
CLCol:		dc.w	$180,0,$182,0,$184,0,$186,0,$188,0,$18a,0,$18c,0,$18e,0
		dc.w	$190,0,$192,0,$194,0,$196,0,$198,0,$19a,0,$19c,0,$19e,0
		dc.w	$1a0,0,$1a2,0,$1a4,0,$1a6,0,$1a8,0,$1aa,0,$1ac,0,$1ae,0
		dc.w	$1b0,0,$1b2,0,$1b4,0,$1b6,0,$1b8,0,$1ba,0,$1bc,0,$1be,0
CLPtr:		dc.w	$e0,0,$e2,0
		dc.w	$e4,0,$e6,0
		dc.w	$e8,0,$ea,0
		dc.w	$ec,0,$ee,0
		dc.w	$f0,0,$f2,0
		dc.w	$f4,0,$f6,0
CLDat:
		dc.w	BPL1MOD,0
		dc.w	BPL2MOD,0
		dc.w	DDFSTRT,0
		dc.w	DDFSTOP,0
		dc.w	DIWSTRT,0
		dc.w	DIWSTOP,0
		dc.w	BPLCON1,0
		dc.w	BPLCON2,0
CL0:		dc.w	$6003,COPWAIT
CLOn:		dc.w	BPLCON0,0
		dc.w	$e403,COPWAIT
CLOff:		dc.w	BPLCON0,0
		dc.w	ENDCOPLST,COPWAIT

Intro0:		incbin	'Intro0.BIN'
Intro1:		incbin	'Intro1.BIN'
Intro2:		incbin	'Intro2.BIN'

* MOD *********************************

rs_song:	;incbin	'RAM:Intro.OKT'
rs_songend:

;*******************************************************************
;			FAST WORK
;*******************************************************************

	;--- System. ---

GfxLibBase:	dc.l	0
MemStack:	dc.l	0
MemDma:		dc.w	0
MemInt:		dc.w	0
MemVectors:	blk.l	64
Stack:		blk.b	STACKSIZE
	EVEN

	;--- VBL. ---

WykonujVBL:	dc.b	0
ByloVBL:	dc.b	0
	EVEN

Pal2B:		blk.w	32,0

;*******************************************************************
;			CHIP WORK
;*******************************************************************

Stop:
